package com.example.football2014;

import java.io.IOException;
import java.io.OutputStream;
import java.util.UUID;

 
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Spinner;
import android.widget.ImageView;

public class MainActivity extends Activity {
  private static final String TAG = "bluetooth1";
   
  Button btnOn;
  Spinner countries1,countries2;
  ImageView imgFlag1,imgFlag2;
  Spinner count1,count2;
   
  private static final int REQUEST_ENABLE_BT = 1;
  private BluetoothAdapter btAdapter = null;
  private BluetoothSocket btSocket = null;
  private OutputStream outStream = null;
   
  // SPP UUID  
  private static final UUID MY_UUID = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");
 
  // MAC- Bluetooth 
  private static String address = "00:11:10:12:06:14";
  //private static String address = "98:D3:31:B1:198C:23";

  String[] counts1 = { "0", "1", "2", "3",  "4", "5", "6", "7", "8", "9" };
  String[] names1 = { "", "", "", "", 
		              "", "", "", "",
		              "-'", "", "", "",
		              "", "-", "", "",
		              "", "", "", "",
		              "", "  ", "", "",
		              "", "", "", "",
	                  " ", "", "", "" };
  Integer[] images1 =  {R.drawable.brazil,R.drawable.croatia,R.drawable.mexico,R.drawable.cameroon,
		                R.drawable.australia,R.drawable.chile,R.drawable.espana,R.drawable.netherlands,
		                R.drawable.cote,R.drawable.japan,R.drawable.greece,R.drawable.colombia,
		                R.drawable.england,R.drawable.costarica,R.drawable.italy,R.drawable.uruguay,
		                R.drawable.ecuadorlux,R.drawable.switzerland,R.drawable.honduras,R.drawable.france,
		                R.drawable.nigeria,R.drawable.bosnia,R.drawable.iranlux,R.drawable.argentinalux,
		                R.drawable.ghana,R.drawable.usa,R.drawable.germany,R.drawable.portugal,
		                R.drawable.skorea,R.drawable.algeria,R.drawable.belgium,R.drawable.russia
                        };

  /** Called when the activity is first created. */
  @Override
  public void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
 
    setContentView(R.layout.activity_main3);
 
    btnOn = (Button) findViewById(R.id.btnOn);
    countries1 = (Spinner) findViewById(R.id.countries1);
    countries2 = (Spinner) findViewById(R.id.countries2);
    count1 = (Spinner) findViewById(R.id.count1);
    count2 = (Spinner) findViewById(R.id.count2);
    imgFlag1 = (ImageView) findViewById(R.id.imgFlag1);
    imgFlag2 = (ImageView) findViewById(R.id.imgFlag2);
    

    
    // 
    ArrayAdapter<String> adapter1 = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, names1);
    adapter1.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
    ArrayAdapter<String> adapter2 = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, names1);
    adapter2.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
    ArrayAdapter<String> adapter3 = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, counts1);
    adapter3.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
    ArrayAdapter<String> adapter4 = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item, counts1);
    adapter4.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
    
    countries1.setAdapter(adapter1);
    countries2.setAdapter(adapter2);
    count1.setAdapter(adapter3);
    count2.setAdapter(adapter4);
    // 
    countries1.setPrompt("1");
    countries2.setPrompt("2");
    count1.setPrompt("1");
    count2.setPrompt("2");
    //   
    countries1.setSelection(0);    
    countries2.setSelection(22);    
    count1.setSelection(0);    
    count2.setSelection(0);    
    countries1.setOnItemSelectedListener(new OnItemSelectedListener() {
         @Override
         public void onItemSelected(AdapterView<?> parent, View view,int position, long id) {
         //    
         //Toast.makeText(getBaseContext(), "Position = " + position, Toast.LENGTH_SHORT).show();
         imgFlag1.setImageResource(images1[position]);
         }
         @Override
         public void onNothingSelected(AdapterView<?> arg0) {
                }
         });
    countries2.setOnItemSelectedListener(new OnItemSelectedListener() {
        @Override
        public void onItemSelected(AdapterView<?> parent, View view,int position, long id) {
        //    
        //Toast.makeText(getBaseContext(), "Position = " + position, Toast.LENGTH_SHORT).show();
        imgFlag2.setImageResource(images1[position]);
        }
        @Override
        public void onNothingSelected(AdapterView<?> arg0) {
               }
        });
   
    
    btAdapter = BluetoothAdapter.getDefaultAdapter();
    checkBTState();
 
    btnOn.setOnClickListener(new OnClickListener() {
      public void onClick(View v) {
    	  byte[] tmpStr=new byte[6];
    	  tmpStr[0]=(byte)(46);
    	  tmpStr[1]=(byte)(countries1.getSelectedItemPosition()+49);
    	  tmpStr[2]=(byte)(countries2.getSelectedItemPosition()+49);
    	  tmpStr[3]=(byte)(count1.getSelectedItemPosition()+48);
    	  tmpStr[4]=(byte)(count2.getSelectedItemPosition()+48);
    	  tmpStr[5]=(byte)(47);
        sendData(new String(tmpStr));
        Toast.makeText(getBaseContext(), " ", Toast.LENGTH_SHORT).show();
      }
    });
 
 
  }
   
  @Override
  public void onResume() {
    super.onResume();
 
    Log.d(TAG, "...onResume -  ...");
    Toast.makeText(getBaseContext(), "...onResume -  ...", Toast.LENGTH_LONG).show();
    // Set up a pointer to the remote node using it's address.
    BluetoothDevice device = btAdapter.getRemoteDevice(address);
   
    // Two things are needed to make a connection:
    //   A MAC address, which we got above.
    //   A Service ID or UUID.  In this case we are using the
    //     UUID for SPP.
    try {
      btSocket = device.createRfcommSocketToServiceRecord(MY_UUID);
    } catch (IOException e) {
      errorExit("Fatal Error", "In onResume() and socket create failed: " + e.getMessage() + ".");
    }
   
    // Discovery is resource intensive.  Make sure it isn't going on
    // when you attempt to connect and pass your message.
    btAdapter.cancelDiscovery();
   
    // Establish the connection.  This will block until it connects.
    Log.d(TAG, "......");
    Toast.makeText(getBaseContext(), "......", Toast.LENGTH_LONG).show();
    try {
      btSocket.connect();
      Log.d(TAG, "...      ...");
      Toast.makeText(getBaseContext(), "...      ...", Toast.LENGTH_LONG).show();
    } catch (IOException e) {
      try {
        btSocket.close();
      } catch (IOException e2) {
        errorExit("Fatal Error", "In onResume() and unable to close socket during connection failure" + e2.getMessage() + ".");
      }
    }
     
    // Create a data stream so we can talk to server.
    Log.d(TAG, "... Socket...");
    Toast.makeText(getBaseContext(), "... Socket...", Toast.LENGTH_LONG).show();
 
    try {
      outStream = btSocket.getOutputStream();
    } catch (IOException e) {
      errorExit("Fatal Error", "In onResume() and output stream creation failed:" + e.getMessage() + ".");
    }
  }
 
  @Override
  public void onPause() {
    super.onPause();
 
    Log.d(TAG, "...In onPause()...");
 
    if (outStream != null) {
      try {
        outStream.flush();
      } catch (IOException e) {
        errorExit("Fatal Error", "In onPause() and failed to flush output stream: " + e.getMessage() + ".");
      }
    }
 
    try     {
      btSocket.close();
    } catch (IOException e2) {
      errorExit("Fatal Error", "In onPause() and failed to close socket." + e2.getMessage() + ".");
    }
  }
   
  private void checkBTState() {
    // Check for Bluetooth support and then check to make sure it is turned on
    // Emulator doesn't support Bluetooth and will return null
    if(btAdapter==null) { 
      errorExit("Fatal Error", "Bluetooth  ");
    } else {
      if (btAdapter.isEnabled()) {
        Log.d(TAG, "...Bluetooth ...");
        Toast.makeText(getBaseContext(), "...Bluetooth ...", Toast.LENGTH_LONG).show();
      } else {
        //Prompt user to turn on Bluetooth
        Intent enableBtIntent = new Intent(btAdapter.ACTION_REQUEST_ENABLE);
        startActivityForResult(enableBtIntent, REQUEST_ENABLE_BT);
      }
    }
  }
 
  private void errorExit(String title, String message){
    Toast.makeText(getBaseContext(), title + " - " + message, Toast.LENGTH_LONG).show();
    finish();
  }
 
  private void sendData(String message) {
    byte[] msgBuffer = message.getBytes();
 
    Log.d(TAG, "... : " + message + "...");
 
    try {
      outStream.write(msgBuffer);
    } catch (IOException e) {
      String msg = "In onResume() and an exception occurred during write: " + e.getMessage();
      if (address.equals("00:00:00:00:00:00")) 
        msg = msg + ".\n\n  address    00:00:00:00:00:00,     MAC- Bluetooth ";
      	msg = msg +  ".\n\n  SPP UUID: " + MY_UUID.toString() + "  Bluetooth ,    .\n\n";
       
      	errorExit("Fatal Error", msg);       
    }
  }
}